/*******************************************************************
 *
 *	File:		ECompXL.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __ECOMPXL_H
#define __ECOMPXL_H



#ifndef __WINS__

/*
 * The GNU linker scripts used by the Symbian OS toolchain are stored in
 *   EPOC32\gcc\arm-epoc-pe\lib\ldscripts and POC32\gcc\thumb-epoc-pe\lib\ldscripts
 * It's a straitforward copy of the ones defined by GCC.
 */

typedef void (*func_ptr) (void);

extern func_ptr __CTOR_LIST__[];
extern func_ptr __DTOR_LIST__[];
inline void call_ctors()
{
	TInt i=1;
	while(__CTOR_LIST__[i])
	{
	    (*__CTOR_LIST__[i++])();
	}
}
inline void call_dtors()
{
	TInt i=1;
	while(__DTOR_LIST__[i])
	    (*__DTOR_LIST__[i++])();
}
#endif


class TECompXL
{
public:
	TECompXL();
	~TECompXL();
};

inline TECompXL::TECompXL()
{
#ifndef __WINS__
	call_ctors();
#endif
}

inline TECompXL::~TECompXL()
{
#ifndef __WINS__
	call_dtors();
#endif
}


#endif			/* __ECOMPXL_H */

