/*******************************************************************
 *
 *	File:		App.cpp
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#include <e32def.h>
#include <e32uid.h>
#include <f32file.h>
#include <eikappui.h>
#include <eikapp.h>
#include <eikdoc.h>
#include "debug.h"
#include "CImageLoader.h"

typedef CApaApplication* (*TNewApplication)();

TUint LoaderL()
{
	CImageLoader*	loader = CImageLoader::NewLC();
	TUint	entry = loader->LoadImageL();
	CleanupStack::PopAndDestroy();
	return entry;
}

GLDEF_C TInt E32Dll(TDllReason)
{
	return KErrNone;
}


EXPORT_C CApaApplication* NewApplication()
{
	TUint entry = 0;
	TRAPD(err, entry = LoaderL());

#ifndef __WINS__
	TNewApplication		newAppFunc = (TNewApplication) entry;
	return newAppFunc();
#else
	return NULL;
#endif
}


