/*******************************************************************
 *
 *	File:		CFileReaderBase.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __C_FILE_READER_BASE_H
#define __C_FILE_READER_BASE_H

const TInt KMaxSectionHeaders	= 16;
const TInt KPageSize			= 4096;


/*
 * Internal section table built from file/section headers info
 */

typedef struct
{
	TUint8*		iImageBase;
	TUint8*		iImageEntyPoint;
} TImageInfo;

typedef struct
{
	TInt		iSize;
	TUint8*		iImageVma;
	TInt		iStartBlock;
	TInt		iLastBlock;

	TUint8*		iLoadedVma;
} TSectionTableEntry;


enum TSectionIndex
{
	KSectionCode = 0,
	KSectionData,
	KSectionBss,
	KSectionImport,
	KSectionReloc,
	KMaxSections
};


class CFileReaderBase : public CBase
{
public:
	~CFileReaderBase(){};
	virtual void LoadHeadersL(TImageInfo& aImageInfo, TSectionTableEntry* aSectionTable) = 0;
	virtual void LoadSectionsL(const TSectionTableEntry* aSectionTable) = 0;

	RFs		iFs;
	RFile	iFile;
};

CFileReaderBase* CreateFileReaderL();




#endif			/* __C_FILE_READER_BASE_H */
