/*******************************************************************
 *
 *	File:		Exe.cpp
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#include <e32def.h>
#include <e32uid.h>
#include <f32file.h>
#include "debug.h"
#include "CImageLoader.h"
#include "Panic.h"


typedef TInt (*TEntryPoint)();

TUint LoaderL()
{
	CImageLoader*	loader = CImageLoader::NewLC();
	TUint	entry = loader->LoadImageL();
	CleanupStack::PopAndDestroy();
	return entry;
}

TInt E32Main()
{
	CTrapCleanup* trapHandler=CTrapCleanup::New();
	if (trapHandler==NULL)
		User::Leave(KErrNoMemory);

	TUint entry = 0;
	TRAPD(err, entry = LoaderL());
	PanicIfError(err, ECompXLPanicLoaderFailed);

	delete trapHandler;

#ifndef __WINS__
	TEntryPoint	entryPointFunc = (TEntryPoint) entry;
	return entryPointFunc();
#else
	return 0;
#endif
}



#ifdef __WINS__
EXPORT_C TInt E32Dll(TDllReason /*aReason*/)
{
	return KErrNone;
}

#endif
