/*******************************************************************
 *
 *	File:		Panic.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __PANIC_H
#define __PANIC_H

enum
{
	ECompXLPanic = 0,
	ECompXLPanicLoaderFailed,

	ECompXLPanicCouldNotConnectToFileServer,	// Generic file I/O
	ECompXLPanicCouldNotOpenOwnImageFile,

	ECompXLPanicCouldNotQueryImageFileSize,		// ECompXL file I/O errors
	ECompXLPanicCouldNotSeekToLastDWord,		// 5
	ECompXLPanicGZipFileOffsetOutOfRange,
	ECompXLPanicCouldNotReadLastDWord,
	ECompXLPanicCouldNotSeekToGZipFileOffset,
	ECompXLPanicInvalidMagicInGZipXLHeader,
	ECompXLPanicInvalidVersionInGZipXLHeader,	// 10
	ECompXLPanicCouldNotReadPartOfImage,

	ECompXLPanicCouldNotReadGzipHeader,
	ECompXLPanicInflateInit2Failed,
	ECompXLPanicInflateError,
	ECompXLPanicInflateEndFailed,				// 15

	ECompXLPanicCouldNotReadExtPEHeader,		// PE file I/O errors 
	ECompXLPanicCouldNotReadAoutPEHeader,
	ECompXLPanicCouldNotReadPESectionHeaders,
	ECompXLPanicNoPECodeSection,
	ECompXLPanicCouldNotSeekToPECodeSection,	// 20
	ECompXLPanicCouldNotReadPECodeSection,
	ECompXLPanicNoPEDataSection,
	ECompXLPanicCouldNotSeekToPEDataSection,
	ECompXLPanicCouldNotReadPEDataSection,
	ECompXLPanicNoPEImportSection,				// 25
	ECompXLPanicCouldNotSeekToPEImportSection,
	ECompXLPanicCouldNotReadPEImportSection,
	ECompXLPanicNoPERelocSection,
	ECompXLPanicCouldNotSeekToPERelocSection,
	ECompXLPanicCouldNotReadPERelocSection,		// 30

	ECompXLPanicCreateCodeChunk,				// image handling
	ECompXLPanicCreateDataChunk,
	ECompXLPanicLoadLibrary,
	ECompXLPanicNotLinkByOrdinal,
	ECompXLPanicRelocOutOfRange,				// 35
	ECompXLPanicUnsupportedRelocType
};

void Panic(TInt aPanic);

inline void PanicIfError(TInt aErr, TInt aPanic)
{
	if (aErr != KErrNone)
		Panic(aPanic);
}

inline void PanicIfNull(TAny* aPtr, TInt aPanic)
{
	if (!aPtr)
		Panic(aPanic);
}

#endif
