/*******************************************************************
 *
 *	File:		Debug.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/


#ifndef __DEBUG_H
#define __DEBUG_H


/*
 * When defined, this spits out loads of usefull logging
 * using RDebug::Print
 */
//#define WANT_DPRINT 1

#include <e32svr.h>

/*
 * Some usefull macro's for debugging
 */

#define HEREL2(l)	L#l
#define HEREL1(l)	HEREL2(l)
#define TO_UNI1(s)	L##s
#define TO_UNI(s)	TO_UNI1(s)
#define HERE_STR(m) TO_UNI(__FILE__) L"(" HEREL1(__LINE__) L") : " L##m
#define HERE(m)	TPtrC((const TText *) HERE_STR(m))

#ifdef WANT_DPRINT
#define DPRINT(x) RDebug::Print x;
#else
#define DPRINT(x) /**/
#endif



#endif			/* __DEBUG_H */
