/*******************************************************************
 *
 *	File:		petran.cpp
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2002, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#include <stdio.h>
#include <string.h>
#include <process.h>

#include "ECompXLWin32Common.h"

static int WantOriginalPetran(int argc, char* argv[])
{
	int wantOriginalPetran = 1;

	for (int i=1 ; i<argc ; i++)
	{
		if (strnicmp(argv[i], "-stack", 6) == 0)
		{
			unsigned	stackSize = 0;
			sscanf(argv[i] + 7, "0x%x", &stackSize);
			if (stackSize & 0x80000000)
				wantOriginalPetran = 0;
		}
	}
	return wantOriginalPetran;
}


static int RunOriginalPetran(int argc, char* argv[])
{
	argv[0] = (char*)KOriginalPetranExe;
	return _spawnvp(_P_WAIT, KOriginalPetranExe, argv);
}

static int RunECompXLTran(int argc, char* argv[])
{
	argv[0] = (char*) KECompXLTran;
	return _spawnvp(_P_WAIT, KECompXLTran, argv);
}


int main(int argc, char* argv[])
{
#ifdef _DEBUG
	printf("***********************************\n");
	printf("*** DEBUG VERSION OF PETRAN *******\n");
	printf("***********************************\n");
#endif

	if (argc == 1)
		PrintBanner();

	if (WantOriginalPetran(argc, argv))
		return RunOriginalPetran(argc, argv);
	return RunECompXLTran(argc, argv);
}

